-- ==============================================================

--                                           MagicRepair 5.4.0

--                                         File: MagicRepair.lua

-- ==============================================================

local L = LibStub("AceLocale-3.0"):GetLocale("MagicRepair")
setmetatable( L, { __index = function(t, text) return text end })

Author = "legrandseb2212"
NumVersion = "5.4.0"
GameVersion = "5.4.0"

function mr_frame()

	frame_magic_repair:SetScript("Onevent", mr_event);
	frame_magic_repair:RegisterEvent("MERCHANT_SHOW");
	frame_magic_repair:RegisterEvent("VARIABLES_LOADED");
	frame_magic_repair:RegisterEvent("GUILDBANKFRAME_CLOSED");
	SLASH_MAGICREPAIR1, SLASH_MAGICREPAIR2 = '/mr', '/magicrepair';
	
end

-- ---------------------------- LOCAL FUNCTION ---------------------------------------


local function ChatMsg(s, force, r, g, b)
   if (force and type(force) ~= "boolean") then
      r, g, b, force = force, r, g, nil
   end 
   if (not MRSilent or force) then
      DEFAULT_CHAT_FRAME:AddMessage(s, r, g, b)
   end
end

local function ChatMsg2(s, force, r, g, b)
   if (force and type(force) ~= "boolean") then
      r, g, b, force = force, r, g, nil
   end 
   if (MRSilentRepair == true or force) then
      DEFAULT_CHAT_FRAME:AddMessage(s, r, g, b)
   end
end


-- ---------------------------- SLASH FUNCTION ---------------------------------------


function SlashCmdList.MAGICREPAIR(msg, editbox)

	if (msg == L["ownonly"] ) then 
		MRToggleOwnonly(true);
		MRChatConfig(true);
	elseif ( msg == L["off"] ) then
		MRToggleOff("off");
		MRChatConfig(true);
	elseif ( msg == L["on"] ) then
		MRToggleOff("on");
		MRChatConfig(true);
	elseif ( msg == L["silent"] ) then
		if ( MRSilent == true ) then
			ChatMsg("|cFFF88017MagicRepair|r :"..L[" Silent mode"].." "..L["ENABLED"], true ,255,255,0);
		elseif ( MRSilent == false ) then
			ChatMsg("|cFFF88017MagicRepair|r :"..L[" Silent mode"].." "..L["DISABLED"], true ,255,255,0);
		end
		ChatMsg("|cFFF88017MagicRepair|r : "..L["/mr silent [ on / off ]"],255,255,0);
	elseif ( msg == L["silent"].." "..L["on"] ) then
		MRSilent = true 
		ChatMsg("|cFFF88017MagicRepair|r :"..L[" Silent mode"].." "..L["ENABLED"], true ,255,255,0);
	elseif ( msg == L["silent"].." "..L["off"] ) then 
		MRSilent = false 
		ChatMsg("|cFFF88017MagicRepair|r :"..L[" Silent mode"].." "..L["DISABLED"], true ,255,255,0);
	elseif ( msg == L["config"] ) then 
		MRChatConfig(true);
	elseif ( msg == L["help"] ) then 
		ChatMsg(L["/mr [ on / off / ownonly / own / guild / guildonly / config / silent ]"], true ,255,255,0); 
	elseif ( IsInGuild() and CanGuildBankRepair() ) then
		if ( msg == L["own"] ) then 
			MRToggleOwn(true);
			MRChatConfig(true);
		elseif ( msg == L["guild"] ) then 
			MRToggleGuild();
			MRChatConfig(true);
		elseif ( msg == L["guildonly"] ) then 
			MRToggleGuildonly();
			MRChatConfig(true);
		else
			ChatMsg("|cFFF88017MagicRepair|r : "..L["/mr help"], true ,255,255,0);
		end
	else
		if (msg == L["own"] or msg == L["guild"] or msg == L["guildonly"]) then
			if ( IsInGuild() ) then
				ChatMsg("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You are not authorized to repair your guild !"].."|r", true);
			else
				ChatMsg("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You are not in a guild !"].."|r", true);
			end
		else
			ChatMsg("|cFFF88017MagicRepair|r : "..L["/mr help"], true ,255,255,0);
		end
		
	end

end


-- ---------------------------- REPAIR TEXT FUNCTION -------------------------------


function msgTextOwn()
		ChatMsg2("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired for "].. "|r: " ..parseCopper(canRepair));
end

function msgTextGuild()
		ChatMsg2("|cFFF88017MagicRepair|r : |cFF00FF00" ..L["Your items have been repaired with the guild for "].. "|r: " ..parseCopper(canRepair).."\n|cFF00FF00"..L["Money guild available for your repairs "].. "|r: " ..parseCopper(GuildBankMoney));
end

function msgTextNoRepairOwn()
	ChatMsg2("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You don't have enough money for repair !"].."\n................ "..L["Are you missing "].. "|r: " ..parseCopper(NotMoney), true);
end

function msgTextNoRepairGuild()
	ChatMsg2("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["There is not enough money in the guild for you fix it !"].."\n................ "..L["Are you missing "].. "|r: " ..parseCopper(NotGuildBankMoney), true);
end


-- ------------------------- EVENT FUNCTION ------------------------------------------


function mr_event(self, event)

	local GetGuildBankMoney = GetGuildBankMoney()
	
	if ( event == "GUILDBANKFRAME_CLOSED" ) then
		
		if ( GetGuildBankMoney >= 1 ) then
			MRGuildMoney = GetGuildBankMoney;
		end
		
	end
	

	if (event == "VARIABLES_LOADED") then
		
		MRLoadVariables();	
		MRChatConfig(true);
		
	end

	if (event == "MERCHANT_SHOW" and CanMerchantRepair() == 1) then
	
		local GuildBankWithdraw = GetGuildBankWithdrawMoney()
		
		canRepair = GetRepairAllCost()
		
		if (GuildBankWithdraw == -1) then
			if ( GetGuildBankMoney == 0 ) then
				GuildBankWithdrawLimit = MRGuildMoney;
			else
				GuildBankWithdrawLimit = GetGuildBankMoney;
			end
		else
			if ( GetGuildBankMoney == 0 ) then
				GuildBankWithdrawLimit = min(GuildBankWithdraw, MRGuildMoney);
			else
				GuildBankWithdrawLimit = min(GuildBankWithdraw, GetGuildBankMoney);
			end
		end
		
		NotMoney = GetRepairAllCost() - GetMoney()
		NotGuildBankMoney = GetRepairAllCost() - GuildBankWithdrawLimit
		GuildBankMoney = GuildBankWithdrawLimit - GetRepairAllCost()
		
		local Cost = GetRepairAllCost()
		
		if (canRepair >= 1) then
		
			if(MRMode == L["ownonly"]) then
			
				if( GetMoney() >= Cost ) then
					RepairAllItems(0);
					msgTextOwn();
				else
					msgTextNoRepairOwn();
				end
			
			elseif ( IsInGuild() and CanGuildBankRepair() ) then
			
				if(MRMode == L["own"]) then
					if( GetMoney() >= Cost ) then
						RepairAllItems(0);
						msgTextOwn();
					elseif( GuildBankWithdrawLimit >= Cost ) then
						msgTextNoRepairOwn();
						RepairAllItems(1);
						msgTextGuild();
					else
						msgTextNoRepairOwn();
						msgTextNoRepairGuild();
					end
				end

				if(MRMode == L["guild"]) then
					if( GuildBankWithdrawLimit >= Cost ) then
						RepairAllItems(1);
						msgTextGuild();
					elseif( GetMoney() >= Cost ) then
						msgTextNoRepairGuild();
						RepairAllItems(0);
						msgTextOwn();
					else
						msgTextNoRepairGuild();
						msgTextNoRepairOwn();
					end
				end
				
				if(MRMode == L["guildonly"]) then
					if( GuildBankWithdrawLimit >= Cost ) then
						RepairAllItems(1);
						msgTextGuild();
					else
						msgTextNoRepairGuild();
					end
				end
			
			else
			
				if ( IsInGuild() ) then
					ChatMsg("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You are not authorized to repair your guild !"].."|r", true);
				else
					ChatMsg("|cFFF88017MagicRepair|r : |cFFFF0000" ..L["You are not in a guild !"].."|r", true);
				end
		
			end
			
		end
		
		if ( GetGuildBankMoney >= 1 ) then
			MRGuildMoney = GetGuildBankMoney;
		end
		
	end
	
end


-- ------------------------------- CONFIG FUNCTION -----------------------------------


function MRChatConfig(force)

		local msgtext = "";
		if(MRMode == L["ownonly"]) then msgtext = L["Repair only from own money"] ; end
		if(MRMode == L["own"]) then msgtext = L["Try to repair from own money first, repair from guild bank if fails"] ; end
		if(MRMode == L["guild"]) then msgtext = L["Try to repair from guild bank first, repair from own money if fails"] ; end
		if(MRMode == L["guildonly"]) then msgtext = L["Repair only from guild bank"] ; end
		if(MRMode == L["off"]) then msgtext = L["Automatic repairs off"] ; end
		if (force == true) then
			ChatMsg("|cFFF88017"..L["MagicRepair mode"].."|r : "..msgtext, true ,255,255,0);
		else
			ChatMsg("|cFFF88017"..L["MagicRepair mode"].."|r : "..msgtext,255,255,0);
		end
		
end

function parseCopper(repair)

    local gold = math.floor(repair / 10000);
	local silver = math.floor((repair % 10000) / 100);
	local copper = (repair % 10000) % 100;
    if (gold > 0 and silver > 0 and copper > 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, gold, 0, 0, silver, 0, 0, copper, 0, 0)
	elseif (gold > 0 and silver > 0 and copper == 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE, gold, 0, 0, silver, 0, 0)
    elseif (gold > 0 and silver == 0 and copper > 0) then
		return format(GOLD_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, gold, 0, 0, copper, 0, 0)
	elseif (gold == 0 and silver > 0 and copper > 0) then
		return format(SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, silver, 0, 0, copper, 0, 0)
	elseif (gold > 0 and silver == 0 and copper == 0) then
		return format(GOLD_AMOUNT_TEXTURE, gold, 0, 0)	
	elseif (gold == 0 and silver > 0 and copper == 0) then	
		return format(SILVER_AMOUNT_TEXTURE, silver, 0, 0)
	else
		return format(COPPER_AMOUNT_TEXTURE, copper, 0, 0)
	end
end


-- --------------------------------- VARIABLES FUNCTION ------------------------------


function MRLoadVariables()

	if MRGuildMoney == nil then
		MRGuildMoney = 10000;
	end
	
	if MRMode == nil then
		MRMode = L["ownonly"];
	end
	
	if MRSilent == nil then
		MRSilent = true;
	end
	
	if MRSilentRepair == nil then
		MRSilentRepair = true;
	end
    
    if MROff == nil then
        MROff = true;
    end
	
	if MROwnonly == nil then
		MROwnonly = true;
	end
	
	if MROwn == nil then
		MROwn = false;
	end
	
	if MRGuild == nil then
		MRGuild = false;
	end
	
	if MRGuildonly == nil then
		MRGuildonly = false;
	end
        
end

function CheckedOff()

		MROff = false
		MROwnonly = false
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["off"]
		
end

function MRToggleOff(info)

	if ( info == "off" ) then 
		CheckedOff();
	elseif ( info == "on" ) then
		MROff = true	
		MROwnonly = true
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["ownonly"]
    elseif MROff then
	    CheckedOff();
    else
		MROff = true	
		MROwnonly = true
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["ownonly"]
    end    

end

function MRToggleSilent()

	if MRSilent then
	    MRSilent = false
    else
		MRSilent = true
	end

end

function MRToggleSilentRepair()

	if MRSilentRepair then
	    MRSilentRepair = false
    else
		MRSilentRepair = true
	end

end

function MRToggleOwnonly()

    if MROwnonly then
	    CheckedOff();
    else
	   MROff = true	
		MROwnonly = true
		MROwn = false
		MRGuild = false
		MRGuildonly = false
		MRMode = L["ownonly"]
    end    

end

function MRToggleOwn()

    if MROwn then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = true
		MRGuild = false
		MRGuildonly = false
		MRMode = L["own"]
    end    

end

function MRToggleGuild()

    if MRGuild then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = false
		MRGuild = true
		MRGuildonly = false
		MRMode = L["guild"]
    end    

end

function MRToggleGuildonly()

    if MRGuildonly then
	    CheckedOff();
    else
	    MROff = true	
		MROwnonly = false
		MROwn = false
		MRGuild = false
		MRGuildonly = true
		MRMode = L["guildonly"]
    end    

end